# NUCLEO-L152RE Nucleo-64 board

## Overview

The STM32 Nucleo-64 board provides an affordable and flexible way for users to try out new concepts and build prototypes with the STM32 microcontroller, which provide various combinations of performance, power consumption, and features ARDUINO® Uno V3 connectivity and ST morpho headers provide an easy means of expanding the functionality of the Nucleo open development platform with a wide choice of specialized shields.

The STM32 Nucleo-64 boards do not require any separate probe, as they integrate the ST-LINK/V2-1 debugger/programmer. 

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um1724-stm32-nucleo64-boards-mb1136-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32L152RE microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32l152re.html)
- [NUCLEO-L152RE board](https://www.st.com/en/evaluation-tools/nucleo-l152re.html)
- [User manual](https://www.st.com/resource/en/user_manual/um1724-stm32-nucleo64-boards-mb1136-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/en/microcontrollers-microprocessors/stm32l152re.html)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1136-default-c03_schematic.pdf)
